#include<cstdio>
#include<cmath>

#define MAX 20000

int L, S, A, B, K;
int a[MAX], b[MAX];
double opt[MAX];
double old[MAX];
char rek[MAX][MAX/4];


//REK[i][j] = ... 0 pokud (i-1, j), 1 pokud (i, j-1), 2 pokud (i-1, j-1)
static inline int rekr(int i, int j)
{
	return (rek[i][j/4] >> (2 * (j % 4))) & 3;	
}
static inline void rekw(int i, int j, int val)
{
	rek[i][j/4] |= val * (1 << (2 * (j % 4)));
}

static inline double distance(double l, double r)
{
	return sqrt( (l - r) * (l - r) + S * S );
}

void dp()
{
	//spocitame pro prvni privoz nalevo a vsechny napravo
	opt[0] = distance(a[0],b[0]);
	for (int j = 1; j < B; j++) {
		opt[j] = opt[j-1] + distance(a[0], b[j]);
		rekw(0, j, 1);
	}

	for (int i = 1; i < A; i++) {
		//ted mam spocitano pro i-1 a vsechna j
		for (int j = 0; j < B; j++) {
			old[j] = opt[j];
			opt[j] = 0;
		}
		//pro i,0
		opt[0] = old[0] + distance(a[i], b[0]);
		//pro i a zbyla j
		for (int j = 1; j < B; j++) {
			opt[j] = distance(a[i], b[j]);
			if (old[j] <= opt[j-1] && old[j] <= old[j-1]) {
				opt[j] += old[j];
				rekw(i, j, 0);
			}
			else if (opt[j-1] <= old[j] && opt[j-1] <= old[j-1]) {
				opt[j] += opt[j-1];
				rekw(i, j, 1);
			}
			else if (old[j-1] <= opt[j-1] && old[j-1] <= old[j]) {
				opt[j] += old[j-1];
				rekw(i, j, 2);
			}
		}
	}
}

void outputK()
{
	int i = A-1, j = B-1;
	while (i >= 0 && j >= 0) {
		K++;
		int r = rekr(i, j);
		switch(r) {
			case 0:
				i--;
				break;
			case 1:
				j--;
				break;
			case 2:
				i--;
				j--;
				break;
		}
	}
	printf("%d\n", K);
}

void output()
{
	int i = A-1, j = B-1;
	while (i >= 0 && j >= 0) {
		printf("%d %d\n", i+1, j+1);
		int r = rekr(i, j);
		switch(r) {
			case 0:
				i--;
				break;
			case 1:
				j--;
				break;
			case 2:
				i--;
				j--;
				break;
		}
	}
}

int main()
{
	scanf("%d%d%d%d", &L, &S, &A, &B);
	for (int i = 0; i < A; i++) {
		scanf("%d", a+i);
	}
	for (int i = 0; i < B; i++) {
		scanf("%d", b+i);
	}

	dp();
	outputK();
	output();

	return 0;
}
