#include <stdio.h>
#include <stdlib.h>

#define MAX 20000
static unsigned posits[2*MAX];
static unsigned nearest[2*MAX];
static unsigned indeg[2*MAX];
static enum
{
  OPEN,
  COVERED,
  DELETED
} status[2*MAX];
static unsigned A, B;

static unsigned res[2*MAX][2];
static unsigned nres;

static unsigned zeros[2 * MAX];
static unsigned nzeros;

static void
deledge (unsigned t)
{
  if (indeg[t] == 0)
    abort ();
  indeg[t]--;
  if (indeg[t] == 0)
    zeros[nzeros++] = t;
}

static void
find_nearest (unsigned froms[], int nfroms, unsigned tos[], int ntos, unsigned ret[], unsigned offset)
{
  int prev = -1, next = 0, i;

  for (i = 0; i < nfroms; i++)
    {
      while (prev < ntos - 1 && tos[prev + 1] <= froms[i])
	prev++;
      while (next < ntos && tos[next] < froms[i])
	next++;

      if (prev == -1)
	ret[i] = next + offset;
      else if (next == ntos
	       || froms[i] - tos[prev] <= tos[next] - froms[i])
	ret[i] = prev + offset;
      else 
	ret[i] = next + offset;
    }
}

static void
recres (unsigned x, unsigned y)
{
  unsigned t;

  if (x > y)
    {
      t = x;
      x = y;
      y = t;
    }

  res[nres][0] = x + 1;
  res[nres][1] = y - A + 1;
  nres++;
}

int main (void)
{
  unsigned i, o, n, L, S;

  scanf("%u %u %u %u",&L,&S,&A,&B);
  for (i = 0; i < A; i++)
    scanf("%u",&posits[i]);
  for (i = 0; i < B; i++)
    scanf("%u",&posits[A + i]);

  find_nearest (posits, A, posits + A, B, nearest, A);
  find_nearest (posits + A, B, posits, A, nearest + A, 0);
  n = A + B;

  for (i = 0; i < n; i++)
    {
      status[i] = OPEN;
      indeg[nearest[i]]++;
    }
  for (i = 0; i < n; i++)
    if (indeg[i] == 0)
      zeros[nzeros++] = i;

  while (nzeros)
    {
      i = zeros[--nzeros];
      if (status[i] == DELETED)
	abort ();

      if (status[i] == OPEN)
	{
	  o = nearest[i];
	  if (status[o] == DELETED)
	    abort ();

	  recres (i, o);

	  if (status[o] == OPEN)
	    {
	      if (status[nearest[o]] == DELETED)
		abort ();

	      deledge (nearest[o]);
	      status[o] = COVERED;
	    }

	  deledge (o);
	}

      status[i] = DELETED;
    }

  for (i = 0; i < n; i++)
    if (status[i] == OPEN)
      {
	o = nearest[i];
	if (status[o] != OPEN || nearest[o] != i)
	  abort ();

	if (i > o)
	  continue;
	recres (i, o);
      }

  printf ("%d\n", nres);
  for (i = 0; i < nres; i++)
    printf ("%d %d\n", res[i][0], res[i][1]);

  return 0;
}
